system-helpers/usr/local/bin/docker_check
Alexander Schäferdiek 13c7335ee3
All checks were successful
continuous-integration/drone/push Build is passing
Fix check_updates and update man reference to point to correct examples
2023-01-27 00:53:23 +01:00

167 lines
No EOL
3.7 KiB
Bash
Executable file

#!/usr/bin/env bash
# usage
usage() {
USAGE=$(cat <<EOF
Usage: docker_check
Checks a list of docker containers and notifies if their state is not up and running. Please see man docker_check.
EOF
)
echo "$USAGE";
}
set -e;
# check for config file
apply_config() {
local config=$1;
if [[ ! -f "$config" ]]; then
echo "No config file specified";
echo "";
usage;
exit 1;
fi
set -a;
# shellcheck disable=SC1090
source "$config";
set +a;
}
source_config() {
local configFallback=$1;
local configGlobalFallback=$2;
if [[ -f "$configFallback" ]]; then
apply_config "$configFallback";
return;
fi
if [[ -f "$configGlobalFallback" ]]; then
apply_config "$configGlobalFallback";
return;
fi
}
check_required() {
type hostname &> /dev/null || { echo "Requiring 'hostname' but it's not installed"; exit 1; }
type docker &> /dev/null || { echo "Requiring 'docker' but it's not installed"; exit 1; }
}
DOCKER_CHECK_LIST_FILE="$HOME/.docker_check.list"
DOCKER_CHECK_GLOBAL_LIST_FILE="/etc/docker_check.list"
DOCKER_CHECK_NOTIFY_LEVELS=("UNKNOWN" "WARNING" "CRITICAL")
CONTAINERS=()
source_config "$HOME/.docker_check.conf" "/etc/docker_check.conf"
check_required
HOSTNAME=$(hostname)
listFileToUse=""
if [[ -f "$DOCKER_CHECK_LIST_FILE" ]]; then
listFileToUse="$DOCKER_CHECK_LIST_FILE"
else
listFileToUse="$DOCKER_CHECK_GLOBAL_LIST_FILE"
fi
if [[ ! -f $listFileToUse ]]; then
echo "$listFileToUse doesn't exist. Add a file which holds one docker container or timer per line.";
echo "";
usage;
exit 1;
fi
echo "Scanning $listFileToUse for containers...";
while IFS='' read -r line || [[ -n "$line" ]]; do
CONTAINERS+=("$line")
echo "-> Found $line";
done < "$listFileToUse"
# check if current status is in array of DOCKER_CHECK_NOTIFY_LEVELS
function shouldLog() {
local VALUE=$1;
for i in "${DOCKER_CHECK_NOTIFY_LEVELS[@]}"; do
if [ "$i" == "$VALUE" ] ; then
echo true;
return;
fi
done
echo false;
}
# log
function log() {
local CONTAINER=$1;
local STATUS=$2;
local MESSAGE=$3;
# shellcheck disable=SC2155
local SHOULD_LOG=$(shouldLog "$STATUS");
if [ "$SHOULD_LOG" = "true" ]; then
local SUBJECT="[docker $HOSTNAME] $STATUS $CONTAINER";
echo "$SUBJECT: $MESSAGE";
notifier "${SUBJECT}" "${MESSAGE}"
fi
}
# get status for a docker container
function checkContainer() {
local CONTAINER=$1;
# shellcheck disable=SC2268
if [ "x${CONTAINER}" == "x" ]; then
log "$CONTAINER" "UNKNOWN" "Container ID or Friendly Name Required"
return;
fi
# shellcheck disable=SC2268
if [ "x$(which docker)" == "x" ]; then
log "$CONTAINER" "UNKNOWN" "Missing docker binary"
return;
fi
docker info > /dev/null 2>&1
# shellcheck disable=SC2181
if [ $? -ne 0 ]; then
log "$CONTAINER" "UNKNOWN" "Unable to talk to the docker daemon"
return;
fi
RUNNING=$(docker inspect --format="{{.State.Running}}" "$CONTAINER" 2> /dev/null)
if [ $? -eq 1 ]; then
log "${CONTAINER}" "UNKNOWN" "$CONTAINER does not exist."
return;
fi
if [ "$RUNNING" == "false" ]; then
log "${CONTAINER}" "CRITICAL" "$CONTAINER is not running."
return;
fi
RESTARTING=$(docker inspect --format="{{.State.Restarting}}" "$CONTAINER")
if [ "$RESTARTING" == "true" ]; then
log "$CONTAINER" "WARNING" "$CONTAINER state is restarting."
return;
fi
#STARTED=$(docker inspect --format="{{.State.StartedAt}}" $CONTAINER)
#NETWORK=$(docker inspect --format="{{range .NetworkSettings.Networks}}{{.IPAddress}}{{end}}" $CONTAINER)
#log "$CONTAINER" "INFO" "$CONTAINER is running. IP: $NETWORK, StartedAt: $STARTED"
log "$CONTAINER" "INFO" "$CONTAINER is running."
return;
}
# execute check for defined containers
for container in "${CONTAINERS[@]}"; do
echo "Checking $container...";
checkContainer "$container"
done